<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightSegment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFlightSegment
 * @subpackage Arrays
 */
class ArrayOfFlightSegment extends AbstractStructArrayBase
{
    /**
     * The FlightSegment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FlightSegment[]
     */
    public $FlightSegment;
    /**
     * Constructor method for ArrayOfFlightSegment
     * @uses ArrayOfFlightSegment::setFlightSegment()
     * @param \StructType\FlightSegment[] $flightSegment
     */
    public function __construct(array $flightSegment = array())
    {
        $this
            ->setFlightSegment($flightSegment);
    }
    /**
     * Get FlightSegment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FlightSegment[]|null
     */
    public function getFlightSegment()
    {
        return isset($this->FlightSegment) ? $this->FlightSegment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightSegment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightSegment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightSegmentForArrayConstraintsFromSetFlightSegment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFlightSegmentFlightSegmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightSegmentFlightSegmentItem instanceof \StructType\FlightSegment) {
                $invalidValues[] = is_object($arrayOfFlightSegmentFlightSegmentItem) ? get_class($arrayOfFlightSegmentFlightSegmentItem) : sprintf('%s(%s)', gettype($arrayOfFlightSegmentFlightSegmentItem), var_export($arrayOfFlightSegmentFlightSegmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightSegment property can only contain items of type \StructType\FlightSegment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightSegment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FlightSegment[] $flightSegment
     * @return \ArrayType\ArrayOfFlightSegment
     */
    public function setFlightSegment(array $flightSegment = array())
    {
        // validation for constraint: array
        if ('' !== ($flightSegmentArrayErrorMessage = self::validateFlightSegmentForArrayConstraintsFromSetFlightSegment($flightSegment))) {
            throw new \InvalidArgumentException($flightSegmentArrayErrorMessage, __LINE__);
        }
        if (is_null($flightSegment) || (is_array($flightSegment) && empty($flightSegment))) {
            unset($this->FlightSegment);
        } else {
            $this->FlightSegment = $flightSegment;
        }
        return $this;
    }
    /**
     * Add item to FlightSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\FlightSegment $item
     * @return \ArrayType\ArrayOfFlightSegment
     */
    public function addToFlightSegment(\StructType\FlightSegment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FlightSegment) {
            throw new \InvalidArgumentException(sprintf('The FlightSegment property can only contain items of type \StructType\FlightSegment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightSegment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FlightSegment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FlightSegment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FlightSegment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FlightSegment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FlightSegment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightSegment
     */
    public function getAttributeName()
    {
        return 'FlightSegment';
    }
}
