<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetProfileReservation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGetProfileReservation
 * @subpackage Arrays
 */
class ArrayOfGetProfileReservation extends AbstractStructArrayBase
{
    /**
     * The GetProfileReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetProfileReservation[]
     */
    public $GetProfileReservation;
    /**
     * Constructor method for ArrayOfGetProfileReservation
     * @uses ArrayOfGetProfileReservation::setGetProfileReservation()
     * @param \StructType\GetProfileReservation[] $getProfileReservation
     */
    public function __construct(array $getProfileReservation = array())
    {
        $this
            ->setGetProfileReservation($getProfileReservation);
    }
    /**
     * Get GetProfileReservation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetProfileReservation[]|null
     */
    public function getGetProfileReservation()
    {
        return isset($this->GetProfileReservation) ? $this->GetProfileReservation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetProfileReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetProfileReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetProfileReservationForArrayConstraintsFromSetGetProfileReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGetProfileReservationGetProfileReservationItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetProfileReservationGetProfileReservationItem instanceof \StructType\GetProfileReservation) {
                $invalidValues[] = is_object($arrayOfGetProfileReservationGetProfileReservationItem) ? get_class($arrayOfGetProfileReservationGetProfileReservationItem) : sprintf('%s(%s)', gettype($arrayOfGetProfileReservationGetProfileReservationItem), var_export($arrayOfGetProfileReservationGetProfileReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GetProfileReservation property can only contain items of type \StructType\GetProfileReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GetProfileReservation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetProfileReservation[] $getProfileReservation
     * @return \ArrayType\ArrayOfGetProfileReservation
     */
    public function setGetProfileReservation(array $getProfileReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($getProfileReservationArrayErrorMessage = self::validateGetProfileReservationForArrayConstraintsFromSetGetProfileReservation($getProfileReservation))) {
            throw new \InvalidArgumentException($getProfileReservationArrayErrorMessage, __LINE__);
        }
        if (is_null($getProfileReservation) || (is_array($getProfileReservation) && empty($getProfileReservation))) {
            unset($this->GetProfileReservation);
        } else {
            $this->GetProfileReservation = $getProfileReservation;
        }
        return $this;
    }
    /**
     * Add item to GetProfileReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\GetProfileReservation $item
     * @return \ArrayType\ArrayOfGetProfileReservation
     */
    public function addToGetProfileReservation(\StructType\GetProfileReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetProfileReservation) {
            throw new \InvalidArgumentException(sprintf('The GetProfileReservation property can only contain items of type \StructType\GetProfileReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GetProfileReservation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetProfileReservation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetProfileReservation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetProfileReservation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetProfileReservation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetProfileReservation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetProfileReservation
     */
    public function getAttributeName()
    {
        return 'GetProfileReservation';
    }
}
