<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfileVoucher ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProfileVoucher
 * @subpackage Arrays
 */
class ArrayOfProfileVoucher extends AbstractStructArrayBase
{
    /**
     * The ProfileVoucher
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProfileVoucher[]
     */
    public $ProfileVoucher;
    /**
     * Constructor method for ArrayOfProfileVoucher
     * @uses ArrayOfProfileVoucher::setProfileVoucher()
     * @param \StructType\ProfileVoucher[] $profileVoucher
     */
    public function __construct(array $profileVoucher = array())
    {
        $this
            ->setProfileVoucher($profileVoucher);
    }
    /**
     * Get ProfileVoucher value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProfileVoucher[]|null
     */
    public function getProfileVoucher()
    {
        return isset($this->ProfileVoucher) ? $this->ProfileVoucher : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProfileVoucher method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProfileVoucher method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProfileVoucherForArrayConstraintsFromSetProfileVoucher(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProfileVoucherProfileVoucherItem) {
            // validation for constraint: itemType
            if (!$arrayOfProfileVoucherProfileVoucherItem instanceof \StructType\ProfileVoucher) {
                $invalidValues[] = is_object($arrayOfProfileVoucherProfileVoucherItem) ? get_class($arrayOfProfileVoucherProfileVoucherItem) : sprintf('%s(%s)', gettype($arrayOfProfileVoucherProfileVoucherItem), var_export($arrayOfProfileVoucherProfileVoucherItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProfileVoucher property can only contain items of type \StructType\ProfileVoucher, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProfileVoucher value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileVoucher[] $profileVoucher
     * @return \ArrayType\ArrayOfProfileVoucher
     */
    public function setProfileVoucher(array $profileVoucher = array())
    {
        // validation for constraint: array
        if ('' !== ($profileVoucherArrayErrorMessage = self::validateProfileVoucherForArrayConstraintsFromSetProfileVoucher($profileVoucher))) {
            throw new \InvalidArgumentException($profileVoucherArrayErrorMessage, __LINE__);
        }
        if (is_null($profileVoucher) || (is_array($profileVoucher) && empty($profileVoucher))) {
            unset($this->ProfileVoucher);
        } else {
            $this->ProfileVoucher = $profileVoucher;
        }
        return $this;
    }
    /**
     * Add item to ProfileVoucher value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileVoucher $item
     * @return \ArrayType\ArrayOfProfileVoucher
     */
    public function addToProfileVoucher(\StructType\ProfileVoucher $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProfileVoucher) {
            throw new \InvalidArgumentException(sprintf('The ProfileVoucher property can only contain items of type \StructType\ProfileVoucher, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProfileVoucher[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProfileVoucher|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProfileVoucher|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProfileVoucher|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProfileVoucher|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProfileVoucher|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfileVoucher
     */
    public function getAttributeName()
    {
        return 'ProfileVoucher';
    }
}
