<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetrieveProfileReservation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRetrieveProfileReservation
 * @subpackage Arrays
 */
class ArrayOfRetrieveProfileReservation extends AbstractStructArrayBase
{
    /**
     * The RetrieveProfileReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetrieveProfileReservation[]
     */
    public $RetrieveProfileReservation;
    /**
     * Constructor method for ArrayOfRetrieveProfileReservation
     * @uses ArrayOfRetrieveProfileReservation::setRetrieveProfileReservation()
     * @param \StructType\RetrieveProfileReservation[] $retrieveProfileReservation
     */
    public function __construct(array $retrieveProfileReservation = array())
    {
        $this
            ->setRetrieveProfileReservation($retrieveProfileReservation);
    }
    /**
     * Get RetrieveProfileReservation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetrieveProfileReservation[]|null
     */
    public function getRetrieveProfileReservation()
    {
        return isset($this->RetrieveProfileReservation) ? $this->RetrieveProfileReservation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetrieveProfileReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetrieveProfileReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetrieveProfileReservationForArrayConstraintsFromSetRetrieveProfileReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetrieveProfileReservationRetrieveProfileReservationItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetrieveProfileReservationRetrieveProfileReservationItem instanceof \StructType\RetrieveProfileReservation) {
                $invalidValues[] = is_object($arrayOfRetrieveProfileReservationRetrieveProfileReservationItem) ? get_class($arrayOfRetrieveProfileReservationRetrieveProfileReservationItem) : sprintf('%s(%s)', gettype($arrayOfRetrieveProfileReservationRetrieveProfileReservationItem), var_export($arrayOfRetrieveProfileReservationRetrieveProfileReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RetrieveProfileReservation property can only contain items of type \StructType\RetrieveProfileReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RetrieveProfileReservation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RetrieveProfileReservation[] $retrieveProfileReservation
     * @return \ArrayType\ArrayOfRetrieveProfileReservation
     */
    public function setRetrieveProfileReservation(array $retrieveProfileReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($retrieveProfileReservationArrayErrorMessage = self::validateRetrieveProfileReservationForArrayConstraintsFromSetRetrieveProfileReservation($retrieveProfileReservation))) {
            throw new \InvalidArgumentException($retrieveProfileReservationArrayErrorMessage, __LINE__);
        }
        if (is_null($retrieveProfileReservation) || (is_array($retrieveProfileReservation) && empty($retrieveProfileReservation))) {
            unset($this->RetrieveProfileReservation);
        } else {
            $this->RetrieveProfileReservation = $retrieveProfileReservation;
        }
        return $this;
    }
    /**
     * Add item to RetrieveProfileReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\RetrieveProfileReservation $item
     * @return \ArrayType\ArrayOfRetrieveProfileReservation
     */
    public function addToRetrieveProfileReservation(\StructType\RetrieveProfileReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetrieveProfileReservation) {
            throw new \InvalidArgumentException(sprintf('The RetrieveProfileReservation property can only contain items of type \StructType\RetrieveProfileReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RetrieveProfileReservation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RetrieveProfileReservation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RetrieveProfileReservation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RetrieveProfileReservation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RetrieveProfileReservation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RetrieveProfileReservation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RetrieveProfileReservation
     */
    public function getAttributeName()
    {
        return 'RetrieveProfileReservation';
    }
}
