<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RetrieveProfile' => '\\StructType\\RetrieveProfile',
            'RetrieveProfileResponse' => '\\StructType\\RetrieveProfileResponse',
            'CreateProfile' => '\\StructType\\CreateProfile',
            'CreateProfileResponse' => '\\StructType\\CreateProfileResponse',
            'ForgottenPassword' => '\\StructType\\ForgottenPassword',
            'ForgottenPasswordResponse' => '\\StructType\\ForgottenPasswordResponse',
            'RetrieveProfileReservations' => '\\StructType\\RetrieveProfileReservations',
            'RetrieveProfileReservationsResponse' => '\\StructType\\RetrieveProfileReservationsResponse',
            'RetrieveProfileVouchers' => '\\StructType\\RetrieveProfileVouchers',
            'RetrieveProfileVouchersResponse' => '\\StructType\\RetrieveProfileVouchersResponse',
            'ModifyProfilePassword' => '\\StructType\\ModifyProfilePassword',
            'ModifyProfilePasswordResponse' => '\\StructType\\ModifyProfilePasswordResponse',
            'CheckForExistingProfileEmail' => '\\StructType\\CheckForExistingProfileEmail',
            'CheckForExistingProfileEmailResponse' => '\\StructType\\CheckForExistingProfileEmailResponse',
            'GetProfileReservations' => '\\StructType\\GetProfileReservations',
            'GetProfileReservationsResponse' => '\\StructType\\GetProfileReservationsResponse',
            'ValidateProfile' => '\\StructType\\ValidateProfile',
            'ValidateProfileResponse' => '\\StructType\\ValidateProfileResponse',
            'PasswordInfo' => '\\StructType\\PasswordInfo',
            'EmailAddressInfo' => '\\StructType\\EmailAddressInfo',
            'UserNameInfo' => '\\StructType\\UserNameInfo',
            'StaffIDInfo' => '\\StructType\\StaffIDInfo',
            'NewPasswordInfo' => '\\StructType\\NewPasswordInfo',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'ProfileInfo' => '\\StructType\\ProfileInfo',
            'ViewProfile' => '\\StructType\\ViewProfile',
            'ArrayOfRetrieveProfileReservation' => '\\ArrayType\\ArrayOfRetrieveProfileReservation',
            'RetrieveProfileReservation' => '\\StructType\\RetrieveProfileReservation',
            'ProfileVouchers' => '\\StructType\\ProfileVouchers',
            'ArrayOfProfileVoucher' => '\\ArrayType\\ArrayOfProfileVoucher',
            'ProfileVoucher' => '\\StructType\\ProfileVoucher',
            'ArrayOfGetProfileReservation' => '\\ArrayType\\ArrayOfGetProfileReservation',
            'GetProfileReservation' => '\\StructType\\GetProfileReservation',
            'ArrayOfFlightSegment' => '\\ArrayType\\ArrayOfFlightSegment',
            'FlightSegment' => '\\StructType\\FlightSegment',
            'ProfileStatus' => '\\StructType\\ProfileStatus',
            'Profile' => '\\StructType\\Profile',
            'Person' => '\\StructType\\Person',
            'ArrayOfAddress' => '\\ArrayType\\ArrayOfAddress',
            'Address' => '\\StructType\\Address',
            'ArrayOfContactInfo' => '\\ArrayType\\ArrayOfContactInfo',
            'ContactInfo' => '\\StructType\\ContactInfo',
            'ArrayOfIdentification' => '\\ArrayType\\ArrayOfIdentification',
            'Identification' => '\\StructType\\Identification',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'Payment' => '\\StructType\\Payment',
            'ArrayOfPreference' => '\\ArrayType\\ArrayOfPreference',
            'Preference' => '\\StructType\\Preference',
            'ArrayOfCompany' => '\\ArrayType\\ArrayOfCompany',
            'Company' => '\\StructType\\Company',
            'ArrayOfBuddyList' => '\\ArrayType\\ArrayOfBuddyList',
            'BuddyList' => '\\StructType\\BuddyList',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
        );
    }
}
