<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckForExistingProfileEmail StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CheckForExistingProfileEmail
 * @subpackage Structs
 */
class CheckForExistingProfileEmail extends TransactionInfo
{
    /**
     * The CheckForExistingProfileEmailRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CheckForExistingProfileEmail
     */
    public $CheckForExistingProfileEmailRequest;
    /**
     * The EmailAddressInfo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\EmailAddressInfo
     */
    public $EmailAddressInfo;
    /**
     * The ActionSuccessful
     * @var bool
     */
    public $ActionSuccessful;
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * Constructor method for CheckForExistingProfileEmail
     * @uses CheckForExistingProfileEmail::setCheckForExistingProfileEmailRequest()
     * @uses CheckForExistingProfileEmail::setEmailAddressInfo()
     * @uses CheckForExistingProfileEmail::setActionSuccessful()
     * @uses CheckForExistingProfileEmail::setExceptions()
     * @param \StructType\CheckForExistingProfileEmail $checkForExistingProfileEmailRequest
     * @param \StructType\EmailAddressInfo $emailAddressInfo
     * @param bool $actionSuccessful
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     */
    public function __construct(\StructType\CheckForExistingProfileEmail $checkForExistingProfileEmailRequest = null, \StructType\EmailAddressInfo $emailAddressInfo = null, $actionSuccessful = null, \StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this
            ->setCheckForExistingProfileEmailRequest($checkForExistingProfileEmailRequest)
            ->setEmailAddressInfo($emailAddressInfo)
            ->setActionSuccessful($actionSuccessful)
            ->setExceptions($exceptions);
    }
    /**
     * Get CheckForExistingProfileEmailRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CheckForExistingProfileEmail|null
     */
    public function getCheckForExistingProfileEmailRequest()
    {
        return isset($this->CheckForExistingProfileEmailRequest) ? $this->CheckForExistingProfileEmailRequest : null;
    }
    /**
     * Set CheckForExistingProfileEmailRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CheckForExistingProfileEmail $checkForExistingProfileEmailRequest
     * @return \StructType\CheckForExistingProfileEmail
     */
    public function setCheckForExistingProfileEmailRequest(\StructType\CheckForExistingProfileEmail $checkForExistingProfileEmailRequest = null)
    {
        if (is_null($checkForExistingProfileEmailRequest) || (is_array($checkForExistingProfileEmailRequest) && empty($checkForExistingProfileEmailRequest))) {
            unset($this->CheckForExistingProfileEmailRequest);
        } else {
            $this->CheckForExistingProfileEmailRequest = $checkForExistingProfileEmailRequest;
        }
        return $this;
    }
    /**
     * Get EmailAddressInfo value
     * @return \StructType\EmailAddressInfo|null
     */
    public function getEmailAddressInfo()
    {
        return $this->EmailAddressInfo;
    }
    /**
     * Set EmailAddressInfo value
     * @param \StructType\EmailAddressInfo $emailAddressInfo
     * @return \StructType\CheckForExistingProfileEmail
     */
    public function setEmailAddressInfo(\StructType\EmailAddressInfo $emailAddressInfo = null)
    {
        $this->EmailAddressInfo = $emailAddressInfo;
        return $this;
    }
    /**
     * Get ActionSuccessful value
     * @return bool|null
     */
    public function getActionSuccessful()
    {
        return $this->ActionSuccessful;
    }
    /**
     * Set ActionSuccessful value
     * @param bool $actionSuccessful
     * @return \StructType\CheckForExistingProfileEmail
     */
    public function setActionSuccessful($actionSuccessful = null)
    {
        // validation for constraint: boolean
        if (!is_null($actionSuccessful) && !is_bool($actionSuccessful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($actionSuccessful, true), gettype($actionSuccessful)), __LINE__);
        }
        $this->ActionSuccessful = $actionSuccessful;
        return $this;
    }
    /**
     * Get Exceptions value
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return $this->Exceptions;
    }
    /**
     * Set Exceptions value
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\CheckForExistingProfileEmail
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this->Exceptions = $exceptions;
        return $this;
    }
}
